<template>
  <main>
    <v-container grid-list-lg>
      <h5 class="headline fw-300 grey--text">Account Settings</h5>
      <v-layout row wrap>
        <v-flex sm6>
          <!-- Court Information -->
          <v-card>
            <v-card-title class="title fw-300 pb-0">Court Information</v-card-title>
            <v-card-text>
              <v-text-field label="Court Name" v-model="data['name']" prepend-icon="chrome_reader_mode"></v-text-field>
              <v-text-field label="Website" v-model="data['website']" prepend-icon="link"></v-text-field>
              <v-text-field label="Image URL" v-model="data['imageUrl']" prepend-icon="image"></v-text-field>
              <v-text-field label="Contact" v-model="data['contact']" prepend-icon="contact_phone"></v-text-field>
              <v-text-field label="Address" v-model="data['address']" prepend-icon="home" multi-line></v-text-field>
            </v-card-text>
          </v-card>
        </v-flex>
        <v-flex sm6>
          <!-- Business Time -->
          <v-card class="mb-3">
            <v-card-title class="title fw-300 pb-0">Business Time</v-card-title>
            <v-card-text>
              <v-menu :close-on-content-click="false" lazy full-width max-width="290">
                <v-text-field slot="activator" label="Opening Time" v-model="data['open_hours_start']" prepend-icon="timer" readonly></v-text-field>
                <v-time-picker v-model="data['open_hours_start']" :allowed-minutes="value => { return value % 30 === 0 }">
                  <template scope="{save, cancel}">
                    <v-divider></v-divider>
                    <v-card-actions>
                      <v-spacer></v-spacer>
                      <v-btn flat @click="cancel">Cancel</v-btn>
                      <v-btn flat primary @click="save">Save</v-btn>
                    </v-card-actions>
                  </template>
                </v-time-picker>
              </v-menu>
              <v-menu :close-on-content-click="false" lazy full-width max-width="290">
                <v-text-field slot="activator" label="Closing Time" v-model="data['open_hours_end']" prepend-icon="timer" readonly></v-text-field>
                <v-time-picker v-model="data['open_hours_end']" :allowed-minutes="value => { return value % 30 === 0 }">
                  <template scope="{save, cancel}">
                    <v-divider></v-divider>
                    <v-card-actions>
                      <v-spacer></v-spacer>
                      <v-btn flat @click="cancel">Cancel</v-btn>
                      <v-btn flat primary @click="save">Save</v-btn>
                    </v-card-actions>
                  </template>
                </v-time-picker>
              </v-menu>
            </v-card-text>
          </v-card>
          <!-- GPS Location -->
          <v-card class="mb-3">
            <v-card-title class="title fw-300 pb-0">GPS Location</v-card-title>
            <v-card-text>
              <v-text-field label="Latitude" v-model="data['lat']" prepend-icon="navigation"></v-text-field>
              <v-text-field label="Longitude" v-model="data['lng']" prepend-icon="near_me"></v-text-field>
            </v-card-text>
          </v-card>

          <!-- Actions -->
          <div style="display: flex;">
            <v-spacer></v-spacer>
            <v-btn primary @click="saveChanges">Save Changes</v-btn>
            <v-snackbar v-model="toast.visibility" bottom class="mb-4">
              {{toast['message']}}
              <v-btn flat primary @click="toast.visibility = false">Close</v-btn>
            </v-snackbar>
          </div>
        </v-flex>
      </v-layout>
    </v-container>
  </main>
</template>
<script>
  import config from '../config'
  export default {
    name: 'account-settings',
    data () {
      return {
        toast: {
          visibility: false
        },
        data: {}
      }
    },
    methods: {
      saveChanges () {
        this.$database.ref(`courts/${config.courtId}`).set(this.data).then(() => {
          this.toast.message = 'Changes saved!'
          this.toast.visibility = true
        })
      }
    },
    created () {
      // Get Court Info
      this.$database.ref(`courts/${config.courtId}`).once('value').then(snapshot => {
        this.data = snapshot.val()
      })
    }
  }
</script>
